UNIT C_datoteka;
        (* Unit koji opisuje objekat koji nasledjuje objekt lista_c*)

INTERFACE(*************************************************************)
        USES U_clan,U_lista,Crt;
  	TYPE
         TPod=record
         prezime_ime:TSlova_20;(* Prezime i ime clana *)
         clanski_broj:Integer;(* broj clanske kartice *)
         iznajmljene_kasete:TKasete; (* niz naslova filmova koji su iznajmljeni *)
         datum_iznajmljivanja:TDatum;(* datum iznajmljivanja kaseta *)
         placeno:Char; (* 'D' ako je placeno odnosno, 'N' ako nije placeno*)
         end;

         TDatoteka=File of TPod;  (* formira se datoteka tipa pod *)
         C_dato=object(lista_c)   (* objekat c_dato nasledjuje objekat *)
          dat:TDatoteka;      (* lista_c sve njegove atribute i *)
                         	(* metode  i dobija jos dve metode *)
          Procedure Upisivanje;   (* za upisivanje u datoteku *)
          Procedure Ucitavanje;   (* i za ucitavanje iz datoteke *)

       	End;

IMPLEMENTATION(********************************************************)

	Procedure C_dato.Upisivanje;
  	Var
         tek : TPelem;
      	 pom_s:TPod;
      	 filmovi:TKasete;
      	 datu:TDatum;
  	Begin
        (* 1. -LP- otvara datoteku za upis *)
      	  tek := glava;
  	  assign(dat,'Clanovi.dat');
      	  rewrite(dat);
        (* 2. -1CP/4- uzima podatke iz liste i upisuje u datoteku *)
      	  while tek <> nil do  (* Sve dok se ne dodje do kraja liste *)
           begin
             tek^.info.FP_iznajmljene(filmovi);(* uzimaju se potrebni podaci *)
             tek^.info.FP_datum(datu);
             with pom_s do
              begin
                prezime_ime:=tek^.info.F_prezimeime;
                clanski_broj:=tek^.info.F_clanskibroj;
                iznajmljene_kasete:=filmovi;
                datum_iznajmljivanja:=datu;
                placeno:=tek^.info.F_placeno;
              end;

             write(dat,pom_s);
             tek:=tek^.veza;
           end; (* Kraj datoteke *)
        (* 3. -P- zatvara datoteku *)
          close(dat);
  	End(*C_dato.Upisivanje*);

	Procedure C_dato.Ucitavanje;
        Var
         pom_s :TPod;
         tek :TPelem;
         j,i:Integer;
        Begin
        (* 1. -LP- otvara datoteku za citanje *)
          assign(dat,'Clanovi.dat');
          reset(dat);
          P_IzbaciSve; (* brise sve iz liste da bi bila prazna *)
        (* 2. -1CP/4- cita datoteku i podatke prebacuje u listu *)
          while not EOF(dat) do
           begin
             read(dat,pom_s);
             new(tek);
             tek^.veza:=nil;
             with pom_s do
              begin
                tek^.info.P_prezimeime(prezime_ime);
                tek^.info.P_clanskibroj(clanski_broj);
                tek^.info.P_iznajmljene(iznajmljene_kasete);
                tek^.info.P_datum(datum_iznajmljivanja);
                tek^.info.P_placeno(placeno);
              end;
             P_Ubaci(tek);   (* ubacuje ucitani podatak u listu *)
           end;
        (* 3. -P- zatvara datoteku *)
          close(dat);
	End(*C_dato.Ucitavanje*);

END.(******************************************************************)
