UNIT U_clan;
        (* osnovni podaci o svakom clanu video kluba *)
INTERFACE(*************************************************************)
        USES Crt;
        TYPE
         TSlova_20=String[20];  (* string duzine najvise 20 karaktera *)

         TDatum=record
          dan:Integer;
          mesec:Integer;
          godina:Integer;
         end;
         TKasete=Array [1..10] of String;

         Clan=Object  (* objekat 'Clan' sa svojim atributima i metodama *)
          Private(* privatni deo kome se pristupa samo preko metoda ovog objekta*)
          prezime_ime:TSlova_20;(* Prezime i ime clana *)
          clanski_broj:Integer;(* broj clanske kartice *)
          iznajmljene_kasete:TKasete; (* niz naslova filmova koji su iznajmljeni *)
          datum_iznajmljivanja:TDatum;(* datum iznajmljivanja kaseta *)
          placeno:Char; (* 'D' ako je placeno, odnosno 'N' ako nije placeno*)

          Public
          Procedure Init;    (* inicijalizacija podataka objekta *)
          Procedure P_prezimeime(const prezimeime_p:TSlova_20); (* Sledece procedure *)
          Procedure P_clanskibroj(const clanskibroj_p:Integer); (* postavljaju *)
          Procedure P_iznajmljene(const iznajmljene_p:TKasete); (* vrednosti*)
          Procedure P_datum(const datum_p:TDatum);           (* u atribute objekta *)
          Procedure P_placeno(const placeno_p:Char);
          Procedure Stampaj;       (* procedura koja stampa atribute objekta*)
          Function F_prezimeime:TSlova_20;  (* Sledece funkcije i procedure uzimaju*)
          Function F_clanskibroj:Integer;    (* podatke  iz atributa i*)
          Procedure FP_iznajmljene(var iznajmljene_fp:TKasete);(* prosledjuju *)
          Procedure FP_datum(var datum_fp:TDatum);    (* ih onome *)
          Function F_placeno:Char;               (* ko ih je trazio *)
        End;

IMPLEMENTATION(*******************************************************)

        Procedure Clan.Init;
        (* podaci dobijaju pocetne vrednosti *)
        Var
         i:Integer;
        Begin
          prezime_ime:='';
          clanski_broj:=0;
          for i:=1 to 10 do iznajmljene_kasete[i]:='';
          with datum_iznajmljivanja do
           begin
            dan:=0;
            mesec:=0;
            godina:=0;
           end;
          placeno:=' ';
        End(*Clan.Init*);

        Procedure Clan.P_prezimeime(const prezimeime_p:TSlova_20);
        Begin
          prezime_ime:=prezimeime_p;
        End(*Clan.P_prezimeime*);

        Procedure Clan.P_clanskibroj(const clanskibroj_p:integer);
        Begin
          clanski_broj:=clanskibroj_p;
        End(*Clan.P_clanskibroj*);

        Procedure Clan.P_iznajmljene(const iznajmljene_p:TKasete);
        Begin
          iznajmljene_kasete:=iznajmljene_p;
        End(*Clan.P_iznajmljene*);

        Procedure Clan.P_datum(const datum_p:TDatum);
        Begin
          datum_iznajmljivanja:=datum_p;
        End(*Clan.P_datum*);

        Procedure Clan.P_placeno(const placeno_p:char);
        Begin
          placeno:=placeno_p;
        End(*Clan.P_placeno*);

        Procedure Clan.Stampaj;
        (* Procedura koja stampa podatke objekta *)
        Var
          i:integer;
        Begin
          write(' Prezime i ime clana : ');
          writeln(Prezime_ime);
          write(' Broj clanske kartice : ');
          writeln(Clanski_broj);
          writeln(' Clan je iznajmio sledece kasete : ');
          for i:=1 to 10 do (* Prolaz kroz niz *)
           begin
             if iznajmljene_kasete[i]<>'' then
              begin
                gotoxy(5,wherey);
                writeln(iznajmljene_kasete[i]);
              end;
           end;
          writeln;
          write(' Datum iznajmljivanja : ');
          with datum_iznajmljivanja do
          writeln(dan,'/',mesec,'/',godina,'.');
          write(' Status : ');
          if placeno='N' then writeln(' Nije placeno ')
          else writeln(' Nema dugovanja. ');
        End(*Clan.Stampaj*);

        Function Clan.F_prezimeime:TSlova_20;
        Begin
          f_prezimeime:=prezime_ime;
        End(*Clan.F_prezimeime*);

        Function Clan.F_clanskibroj:Integer;
        Begin
          f_clanskibroj:=clanski_broj;
        End(*Clan.F_clanskibroj*);

        Procedure Clan.FP_iznajmljene(var iznajmljene_fp:TKasete);
        Var
         i:Integer;
        Begin
          for i:=1 to 10 do
          iznajmljene_fp[i]:=iznajmljene_kasete[i];
        End(*Clan.FP_iznajmljene*);

        Procedure Clan.FP_datum(var datum_fp:TDatum);
        Begin
          datum_fp:=datum_iznajmljivanja;
        End(*Clan.FP_datum*);

        Function Clan.F_placeno:Char;
        Begin
          f_placeno:=placeno;
        End(*Clan.F_placeno*);
END.