UNIT U_lista;
        (* unit koji definise listu i operacije nad objektom 'lista_c' *)

INTERFACE(*************************************************************)
        USES U_clan,Crt;
        TYPE
         TPelem=^cvor;   (* pokazivac na elemenat tipa cvor *)
         cvor=record  (* cvor je zapis sa dva polja *)
          info:Clan;   (* element liste tipa objekat *)
          veza:TPelem; (*  pokazivac na sledeci elemenat liste *)
         end;

         Lista_c =Object     (* objekt 'lista_c' koji vrsi osnovne operacije nad *)
                                    (* listom *)
          glava:TPelem;(* atribut objekta - pokazivac na prvi elemenat liste *)

          CONSTRUCTOR Init;    (* inicijalizacija objekta liste *)
          Procedure Sacekaj;
          Function VelikaSlova(rec:String):String;(* pretvara slova date reci u velika*)
          Procedure P_Ubaci(var nov_u:TPelem);(*ubacuje elem. tipa Pelem na prvo mesto  u listi *)
          Procedure P_Izbaci;(*brise prvi elemenat tipa Pelem iz liste*)
          Procedure P_IzbaciSve;   (* brise citavu listu *)
          Procedure P_DaLiPostoji_ime(const prezimeime_i:TSlova_20;var gde:TPelem);
          (*ispituje da li postoji objekat sa trazenim imenom u listi*)
          Procedure P_DaLiPostoji_broj(const broj:Integer;var gde:TPelem);
          (*ispituje da li postoji objekat sa trazenim brojem clanske karte u listi*)
          Procedure Stampaj;  (* stampa sve elemente liste *)
          Function F_Prebroj:Integer;(* za odredjivanje sledeceg clanskog broja *)
        End;

IMPLEMENTATION(********************************************************)

        Constructor Lista_c.Init;                    (* inicijalizuje *)
        Begin
        (*1.  -L- inicijalizacija pokazivaca *)      (* pokazivac liste *)
          glava:=nil;                                     (* na nil *)
        End;

        Procedure Lista_c.Sacekaj;
        Begin
        (*1.  -LP- pravi pauzu posle ispisa i ceka na znak za nastavak*)
          writeln;
          writeln(' Pritisnite neki taster za nastavak rada ! ');
          readkey;
         clrscr;
        End(*Lista_c.Sacekaj*);


        Function Lista_c.VelikaSlova(rec:String):String;
        (* Funkcija koja sva slova zadate reci pretvara u velika *)
        (* i vraca tu novostvorenu rec *)
        Var
          rec2:String;
          i:Integer;
        Begin
        (*1. -L- *)
          rec2:='';
        (* 2. 1CP/3 *)
          for i:=1 to length(rec) do
           begin
             rec[i]:=upcase(rec[i]);
             rec2:=rec2+rec[i];
           end;
        (*3. -L- *)
          VelikaSlova:=rec2;
        End(*Lista_c.VelikaSlova*);

        Procedure Lista_c.P_Ubaci(var nov_u:TPelem);
        Var
          pre,sad:TPelem;
          nasao:Boolean;
        Begin
        (* 1  -L- *)
          nov_u^.veza:=glava;
          glava:=nov_u;
        End(*Lista_c.P_Ubaci*);

        Procedure Lista_c.P_Izbaci;
        Var
          pom:TPelem;
        Begin
        (* 1. -L- *)
          pom:=glava;
          glava:=glava^.veza;(* glava pokazuje na drugi elemenat liste *)
        (*2. -P- izbaci ga *)
          dispose(pom); (* Oslobadjanje memorijskog prostora *)
        End(*Lista_c.P_Izbaci*);

        Procedure Lista_c.P_IzbaciSve;
        Var
          pom:TPelem;
        Begin
        (*1. -1CP/4- izbaci sve *)
          while glava <> nil do  (* dok se ne dodje do kraja liste *)
           begin
             pom:=glava;
             glava:=glava^.veza;
             dispose(pom);   (* Oslobadjanje memorijskog prostora *)
           end;
        End(*Lista_c.P_Izbaci_sve*);

        Procedure Lista_c.P_DaLiPostoji_ime(const prezimeime_i:TSlova_20;var gde:TPelem);
        (* Ukoliko postoji objekat sa trazenim imenom pokazivac 'gde' se *)
                           (* postavlja na njega *)
        Var
          pom:TPelem;
          log:Boolean;
        Begin
        (*1. -L- *)
          pom:=glava;
          log:=false;
        (*2. -1C2RP/4- pokusaj ga pronaci *)
          while (pom<>nil) and (log=false) do (* Dok se ne pronadje ili *)
           begin   (* dok se ne dodje do kraja liste *)
             if VelikaSlova(pom^.info.f_prezimeime) = VelikaSlova(prezimeime_i)
             (* pretvaranje u velika slova i uporedivanje *)
               then begin (* Pronasao ga je *)
                      log:=true;
                      gde:=pom;
                    end;
             pom:=pom^.veza;
           end;
        (*3. -2R- ako nema onda 'gde' dobija vrednost nil *)
          if log = false then  gde:=nil;
        End(*Lista_c.P_IzbaciSve*);

        Procedure Lista_c.P_DaLiPostoji_broj(const broj:Integer;var gde:TPelem);
        (* Ukoliko postoji objekat sa trazenim clanskim brojem pokazivac 'gde' se *)
                  (* postavlja na njega *)
        Var
          pom:TPelem;
          log:boolean;
        Begin
        (*1. -L- *)
          pom:=glava;
          log:=false;
        (*2. -1C2RP/4- pokusaj ga pronaci *)
          while (pom<>nil) and (log=false) do (* Dok se ne pronadje ili *)
           begin   (* dok se ne dodje do kraja liste *)
             if pom^.info.f_clanskibroj = broj (* uporedjivanje *)
               then begin (* Pronasao ga je *)
                      log:=true;
                      gde:=pom;
                    end;
             pom:=pom^.veza;
           end;
        (*3. -2R- ako nema onda 'gde' je nil *)
          if log = false then  gde:=nil;
        End(*Lista_c.P_DaLiPostoji_broj*);

        Procedure Lista_c.Stampaj;
        Var
          pom:TPelem;
          samo:Char;
        Begin
        (*1. -LP-*)
          clrscr;
          pom:=glava;
        (*2.- 2RS(LP;1CP/4) - *)
          if pom=nil then (* Prazna lista *)
           begin
             gotoxy(3,3);
             writeln(' Ne postoji nijedan clan u evidenciji !');
             Sacekaj;
           end
          else        (* Nije prazna *)
           begin
             while pom<>nil do (* sve dok se ne dodje do kraja liste *)
              begin
                gotoxy(1,4);
                pom^.info.Stampaj;(* Poziv procedure za stampanje elementa liste *)
                Sacekaj;
                pom:=pom^.veza;(* pokazivac 'pom' pokazuje na sledeci elemenat *)
              end;
           end;
        End(*Lista_c.Stampaj*);

        Function Lista_c.F_Prebroj:Integer;
        Var
          pom:TPelem;
          i:Integer;
        Begin
        (* 1.- L - *)
          i:=0;         (* Inicijalizacija brojaca *)
          pom:=glava;   (* postavlja se pokazivac na pocetak liste *)
        (* 2. - 1C/4 - *)
           while pom<>nil do (* Ciklus se ponavlja ...*)
            begin
              i:=i+1;        (* Brojac se povecava za 1*)
              pom:=pom^.veza;(* pomera se za po jedno mesto u svakom ciklusu *)
            end;            (*... Sve dok se ne dodje do kraja liste *)
        (* 3. - L - *)
           F_Prebroj:=i; (* funkcija dobija odgovarajucu vrednost *)
        End(*Lista_c.F_Prebroj*);

END.(*****************************************************************)